# Copyright (C) 1997 Kaoru Nakajima

# $BK\%W%m%0%i%`$O%U%j!<!&%W%m%0%i%`$G$9!#$"$J$?$O!"(BFree Software
# Foundation $B$,8xI=$7$?(B GNU $B0lHL8xM-;HMQ5vBz$N!V%P!<%8%g%s#2!W0?$O$=$l(B
# $B0J9_$N3F%P!<%8%g%s$NCf$+$i$$$:$l$+$rA*Br$7!"$=$N%P!<%8%g%s$,Dj$a$k>r9`$K(B
# $B=>$C$FK\%W%m%0%i%`$r:FG[I[$^$?$OJQ99$9$k$3$H$,$G$-$^$9!#(B

# $BK\%W%m%0%i%`$OM-MQ$H$O;W$$$^$9$,!"G[I[$K$"$?$C$F$O!";T>l@-5Z$SFCDjL\E*(B
# $BE,9g@-$K$D$$$F$N0EL[$NJ]>Z$r4^$a$F!"$$$+$J$kJ]>Z$b9T$$$^$;$s!#>\:Y$K(B
# $B$D$$$F$O(B GNU $B0lHL8xM-;HMQ5vBz=q$r$*FI$_2<$5$$!#(B

# $B$"$J$?$O!"K\%W%m%0%i%`$H0l=o$K(B GNU $B0lHL8xM-;HMQ5vBz$N<L$7$r<u$1<h$C$F(B
# $B$$$k$O$:$G$9!#$=$&$G$J$$>l9g$O!"(BFree Software Fundation, Inc., 675 Mass
# Ave, Cambridge, MA 02139, USA $B$X<j;f$r=q$$$F2<$5$$!#(B

# $B:n<T$X$NO"Mm$O0J2<$X$*4j$$$7$^$9!#(B
# E-mail: knak@mix.or.jp

package Xtalk;

my $prompt_pattern = '';

sub BEGIN
{
use Fcntl;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(setprompt talk);

open(PTYIN, "<&=3");
open(PTYOUT, ">&=4");
$| = 1;
select PTYOUT;
$| = 1;
select PTYIN;
$| = 1;
select STDOUT;
$* = 1;

fcntl(PTYIN, F_SETFL, O_NONBLOCK);
}

sub setprompt
{
	my($prompt) = @_;
	$prompt_pattern = $prompt;
}

sub talk
{
	my ($cmd) = @_;
	my ($rin, $rout) = ('', '');
	my $buf = '';
#	my $len = 0;

	print PTYOUT $cmd;
	vec($rin, fileno(PTYIN), 1) = 1;
	do {
		select($rout = $rin, undef, undef, 0.1);
		while(sysread(PTYIN, $buf, 1024, length($buf)) == 1024) {
			select($rout = $rin, undef, undef, 0.05);
		}
#		print STDERR substr($buf, $len);
#		$len = length($buf);
	} until ($buf =~ /$prompt_pattern$/);
	return $buf;
}

1;
